package gitpb

import "go.wit.com/log"

func (repo *Repo) SetReadOnly(b bool) {
	repo.ReadOnly = b
}

func (repo *Repo) SetTargetVersion(target string) {
	repo.TargetVersion = target
}

func (repo *Repo) SetMasterBranchName(s string) {
	log.Info("gitpb.SetMaster() SET MASTER TO", s)
	repo.MasterBranchName = s
}

func (repo *Repo) GetGoPath() string {
	if repo.GoInfo == nil {
		return ""
	}
	return repo.GoInfo.GoPath
}

func (repo *Repo) GetGoPrimitive() bool {
	if repo.GoInfo == nil {
		return false
	}
	return repo.GoInfo.GoPrimitive
}

func (repo *Repo) SetGoPrimitive(b bool) {
	if repo.GoInfo == nil {
		repo.GoInfo = new(GoInfo)
	}
	repo.GoInfo.GoPrimitive = b
}
